package cc.fascinated.bat;

import cc.fascinated.bat.service.DiscordService;
import lombok.extern.log4j.Log4j2;
import net.dv8tion.jda.api.JDA;
import net.dv8tion.jda.api.entities.emoji.Emoji;

/**
 * @author Fascinated (fascinated7)
 */
@Log4j2
public class Emojis {
    public static final Emoji SPOTIFY_EMOJI;
    public static final Emoji CHECK_MARK_EMOJI;
    public static final Emoji CROSS_MARK_EMOJI;
    public static final Emoji SAD_FACE_EMOJI;
    public static final Emoji PAUSE_EMOJI;
    public static final Emoji PLAY_EMOJI;
    public static final Emoji SKIP_EMOJI;

    /**
     * Presence Status Emojis
     */
    public static final Emoji ONLINE_EMOJI;
    public static final Emoji IDLE_EMOJI;
    public static final Emoji DND_EMOJI;
    public static final Emoji OFFLINE_EMOJI;

    static {
        log.info("Loading emojis...");
        JDA jda = DiscordService.JDA;
        SPOTIFY_EMOJI = jda.getEmojiById("1256629771975266479");
        CHECK_MARK_EMOJI = jda.getEmojiById("1256633734065557676");
        CROSS_MARK_EMOJI = jda.getEmojiById("1256634487429922897");
        SAD_FACE_EMOJI = jda.getEmojiById("1256636078258131055");
        ONLINE_EMOJI = jda.getEmojiById("1256662465668710430");
        IDLE_EMOJI = jda.getEmojiById("1256662632203685991");
        DND_EMOJI = jda.getEmojiById("1256662572933845032");
        OFFLINE_EMOJI = jda.getEmojiById("1256662679402053662");
        PAUSE_EMOJI = Emoji.fromUnicode("⏸");
        PLAY_EMOJI = Emoji.fromUnicode("▶");
        SKIP_EMOJI = Emoji.fromUnicode("⏭");
        log.info("Loaded emojis!");
    }
}
