package cc.fascinated.bat.command;

import cc.fascinated.bat.model.BatGuild;
import cc.fascinated.bat.model.BatUser;
import lombok.NonNull;
import net.dv8tion.jda.api.entities.Member;
import net.dv8tion.jda.api.entities.channel.middleman.MessageChannel;
import net.dv8tion.jda.api.interactions.commands.SlashCommandInteraction;

/**
 * @author Fascinated (fascinated7)
 */
public interface BatCommandExecutor {
    /**
     * Executes the command using a slash command event.
     *
     * @param guild       the bat guild the command was executed in (null if the command was executed in a DM)
     * @param user        the bat user that executed the command
     * @param channel     the channel the command was executed in
     * @param member      the member that executed the command
     * @param event the slash command event
     */
    default void execute(
            BatGuild guild,
            @NonNull BatUser user,
            @NonNull MessageChannel channel,
            Member member,
            @NonNull SlashCommandInteraction event
    ) {
    }
}
