package cc.fascinated.bat.model.token.beatsaber.scoresaber;

import lombok.AllArgsConstructor;
import lombok.Getter;

@Getter
public class ScoreSaberAccountToken {
    /**
     * The id for this ScoreSaber account.
     */
    private String id;

    /**
     * The name for this account.
     */
    private String name;

    /**
     * The profile picture for this account.
     */
    private String profilePicture;

    /**
     * The bio for this account.
     */
    private String bio;

    /**
     * The country for this account.
     */
    private String country;

    /**
     * The PP for this account.
     */
    private double pp;

    /**
     * The rank for this account.
     */
    private int rank;

    /**
     * The country rank for this account.
     */
    private int countryRank;

    /**
     * The role for this account.
     */
    private String role;

    /**
     * The badges for this account.
     */
    private Badge[] badges;

    /**
     * The history of the rank for this account.
     */
    private String histories;

    /**
     * The permissions for this account.
     */
    private int permissions;

    /**
     * The banned status for this account.
     */
    private boolean banned;

    /**
     * The inactive status for this account.
     */
    private boolean inactive;

    /**
     * The score stats for this account.
     */
    private ScoreStats scoreStats;

    /**
     * The first time this account was seen.
     */
    private String firstSeen;

    /**
     * The badge for this account.
     */
    @AllArgsConstructor
    @Getter
    public static class Badge {
        /**
         * The image for this badge.
         */
        private String image;

        /**
         * The description for this badge.
         */
        private String description;
    }

    /**
     * The score stats for this account.
     */
    @AllArgsConstructor
    @Getter
    public static class ScoreStats {
        /**
         * The total score for this account.
         */
        private long totalScore;

        /**
         * The total ranked score for this account.
         */
        private long totalRankedScore;

        /**
         * The average ranked accuracy for this account.
         */
        private double averageRankedAccuracy;

        /**
         * The total play count for this account.
         */
        private int totalPlayCount;

        /**
         * The ranked play count for this account.
         */
        private int rankedPlayCount;

        /**
         * The replays watched for this account.
         */
        private int replaysWatched;
    }
}
